/*  Project medit
	Project Team DoGA
	Copyright (c) 1995. All Rights Reserved.

	TuVXe:    medit.apx Application
	t@C:        status.cpp
	쐬:          Taka2


	Tv
	====
	TWinStatus (TWindow) ̃Cve[Vp̃\[Xt@C
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\button.h>
#include <owl\statusba.h>
#include <owl\gadget.h>
#include <owl\textgadg.h>
#include "status.h"
#include "matrix.h"
#include "anim.h"
#include "motion.h"
#include "bezier.h"
#include "mecha.h"
#include "suflib.h"
#include "syscolor.h"
#include "dinput.h"
#include "drange.h"

#include "log.h"

#define ws (textwidth / 2)
#define hs (textheight-1)
#define ss 1 //(textheight / 4)

//
// ̃AvP[Vŏ邷ׂẴbZ[W^R}h
// e[u쐬
//
DEFINE_RESPONSE_TABLE1(TWinStatus, TWindow)
//{{TWinStatusRSP_TBL_BEGIN}}
    EV_WM_LBUTTONDOWN,
//{{TWinStatusRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TWinStatus Implementation}}


TWinStatus::TWinStatus (TWindow* parent, AnimationData *dat, int x, int y, int w, int h):
	TWindow(parent, 0, 0)
{
	SetBkgndColor(TColor::LtGray);

	anim = dat;
	nowstatus = STAT_INIT;
	Attr.X = x;
	Attr.Y = y;
	Attr.W = w;
	Attr.H = h;
}


TWinStatus::~TWinStatus ()
{
	Destroy();

	// INSERT>> fXgN^p̃R[h͂

}

void TWinStatus::VectorOutInt(TDC& dc, int x, int y, Vector &v)
{
	char str[16];
	sprintf(str, "%5.0lf     ", v.x); 	dc.TextOut(x, y       , str);
	sprintf(str, "%5.0lf     ", v.y); 	dc.TextOut(x, y + hs  , str);
	sprintf(str, "%5.0lf     ", v.z); 	dc.TextOut(x, y + hs*2, str);
}

void TWinStatus::VectorOutFloat(TDC& dc, int x, int y, Vector &v)
{
	char str[16];
	sprintf(str, "%5.2lf     ", v.x); 	dc.TextOut(x, y       , str);
	sprintf(str, "%5.2lf     ", v.y); 	dc.TextOut(x, y + hs  , str);
	sprintf(str, "%5.2lf     ", v.z); 	dc.TextOut(x, y + hs*2, str);
}

void TWinStatus::DisplayPosition(Vector& v)
{
	TClientDC dc(*this);
	dc.SetBkColor(TColor(cTextBG));
	VectorOutInt(dc, textwidth*3, hs* 2+ss*3, v);

}

void TWinStatus::DisplayTarget(Vector& v)
{
	TClientDC dc(*this);
	dc.SetBkColor(TColor(cTextBG));
	VectorOutInt(dc, textwidth*3, hs* 6+ss*4, v);
}

void TWinStatus::DisplayRotation(Vector& v)
{
	TClientDC dc(*this);
	dc.SetBkColor(TColor(cTextBG));
	VectorOutInt(dc, textwidth*3, hs* 6+ss*4, rad(1) * v);
}

void TWinStatus::DisplayRotationYZ(Vector& v)
{
	TClientDC dc(*this);
	dc.SetBkColor(TColor(cTextBG));
	char str[16];
	sprintf(str, "%5.0lf     ", rad(v.y)); 	dc.TextOut(textwidth*3, hs*8+ss*4, str);
	sprintf(str, "%5.0lf     ", rad(v.z)); 	dc.TextOut(textwidth*3, hs*9+ss*4, str);
}

void TWinStatus::DisplayScale(Vector& v)
{
	TClientDC dc(*this);
	dc.SetBkColor(TColor(cTextBG));
	VectorOutFloat(dc, textwidth*3, hs*10+ss*5, v);
}

void TWinStatus::Redraw(void)
{
	if (UpdateStatus() == FALSE) {
		DisplayStatus(TRUE);
	}
}

void TWinStatus::DisplayStatusObject(TDC& dc, int flag, Motion *m)
{
	if (flag == TRUE) {
		dc.Rectangle(dc.GetClipBox());
		dc.TextOut(ws, hs* 1+ss*3, "ʒu");
		dc.TextOut(ws, hs* 2+ss*3, "X:");
		dc.TextOut(ws, hs* 3+ss*3, "Y:");
		dc.TextOut(ws, hs* 4+ss*3, "Z:");
		dc.TextOut(ws, hs* 5+ss*4, "]");
		dc.TextOut(ws, hs* 6+ss*4, "X:");
		dc.TextOut(ws, hs* 7+ss*4, "Y:");
		dc.TextOut(ws, hs* 8+ss*4, "Z:");
		dc.TextOut(ws, hs* 9+ss*5, "g");
		dc.TextOut(ws, hs*10+ss*5, "X:");
		dc.TextOut(ws, hs*11+ss*5, "Y:");
		dc.TextOut(ws, hs*12+ss*5, "Z:");
	}
	char str[120];

	m->GetName(str);
	sprintf(str + strlen(str), " (%d-%d)     ", m->beginframe, m->endframe);
	dc.TextOut(ws,  ss, str);
	if (m->beginframe <= anim->selectframe && anim->selectframe <= m->endframe) {
		VectorOutInt  (dc, textwidth*3, hs* 2+ss*3, m->position);
		VectorOutInt  (dc, textwidth*3, hs* 6+ss*4, rad(1) * m->rotation);
		VectorOutFloat(dc, textwidth*3, hs*10+ss*5, m->scale);
	} else {
		dc.Rectangle  (    textwidth*3, hs* 2+ss*3, textwidth*15, hs* 5+ss*3);
		dc.Rectangle  (    textwidth*3, hs* 6+ss*4, textwidth*15, hs* 9+ss*4);
		dc.Rectangle  (    textwidth*3, hs*10+ss*5, textwidth*15, hs*13+ss*5);
	}
}

void TWinStatus::DisplayStatusCamera(TDC& dc, int flag, CameraMotion *m)
{
	if (flag == TRUE) {
		dc.Rectangle(dc.GetClipBox());
		dc.TextOut(ws,       ss  , "J");
		dc.TextOut(ws, hs *1+ss*3, "Jʒu");
		dc.TextOut(ws, hs *2+ss*3, "X:");
		dc.TextOut(ws, hs *3+ss*3, "Y:");
		dc.TextOut(ws, hs *4+ss*3, "Z:");
		dc.TextOut(ws, hs *5+ss*4, "ޯĈʒu");
		dc.TextOut(ws, hs *6+ss*4, "X:");
		dc.TextOut(ws, hs *7+ss*4, "Y:");
		dc.TextOut(ws, hs *8+ss*4, "Z:");
	}
	if (m->beginframe <= anim->selectframe && anim->selectframe <= m->endframe) {
		VectorOutInt(dc, textwidth*3, hs* 2+ss*3, m->position);
		VectorOutInt(dc, textwidth*3, hs* 6+ss*4, m->target->position);
	}
}

void TWinStatus::DisplayStatusTarget(TDC& dc, int flag, CameraMotion *m)
{
	if (flag == TRUE) {
		dc.Rectangle(dc.GetClipBox());
		dc.TextOut(ws,       ss  , "^[Qbg");
		dc.TextOut(ws, hs *1+ss*3, "Jʒu");
		dc.TextOut(ws, hs *2+ss*3, "X:");
		dc.TextOut(ws, hs *3+ss*3, "Y:");
		dc.TextOut(ws, hs *4+ss*3, "Z:");
		dc.TextOut(ws, hs *5+ss*4, "ޯĈʒu");
		dc.TextOut(ws, hs *6+ss*4, "X:");
		dc.TextOut(ws, hs *7+ss*4, "Y:");
		dc.TextOut(ws, hs *8+ss*4, "Z:");
	}
	if (m->beginframe <= anim->selectframe && anim->selectframe <= m->endframe) {
		VectorOutInt(dc, textwidth*3, hs* 2+ss*3, m->position);
		VectorOutInt(dc, textwidth*3, hs* 6+ss*4, m->target->position);
	}
}

void TWinStatus::DisplayStatusLight(TDC& dc, int flag)
{
	if (flag == TRUE) {
		dc.Rectangle(dc.GetClipBox());
		dc.TextOut(ws,       ss  , "ݒ");
		dc.TextOut(ws, hs* 1+ss*3, "");
		dc.TextOut(ws, hs* 2+ss*3, "X:");
		dc.TextOut(ws, hs* 3+ss*3, "Y:");
		dc.TextOut(ws, hs* 4+ss*3, "Z:");
		Vector tmpvec = anim->org_point;
		double l = tmpvec.length();
		if (l > minimumdouble) {
			tmpvec *= (100.0/l);
		}
		VectorOutInt(dc, textwidth*3, hs* 2+ss*3, tmpvec);
	}
}

void TWinStatus::DisplayStatus(int flag)
{
	char str[128];
	TClientDC dc(*this);
	dc.SelectObject(TPen(cTextBG));
	dc.SelectObject(TBrush(cTextBG));
	dc.SetBkColor(TColor(cTextBG));
	switch (nowstatus) {
	case STAT_NONE:
		if (flag == TRUE) {
			dc.Rectangle(dc.GetClipBox());
		}
		break;
	case STAT_OBJ:
		DisplayStatusObject(dc, flag, anim->select);
		break;
	case STAT_CAMERA:
		DisplayStatusCamera(dc, flag, anim->camera);
		break;
	case STAT_TARGET:
		DisplayStatusTarget(dc, flag, anim->camera);
		break;
	case STAT_LIGHT:
		DisplayStatusLight(dc, flag);
		break;
	case STAT_SELZOOM:
		break;
	case STAT_PLAY:
		if (anim->select == anim->camera) {
			DisplayStatusCamera(dc, flag, anim->camera);
		} else if (anim->select == anim->camera->target) {
			DisplayStatusTarget(dc, flag, anim->camera);
		} else if (anim->select != NULL) {
			DisplayStatusObject(dc, flag, anim->select);
		}
		break;
	}

#if 0
	if (flag == TRUE) {
		dc.TextOut(ws,       ss  , ":");
	}
	sprintf(str, "%3d     ", anim->selectframe);
	dc.TextOut(textwidth*4, ss, str);
#endif
	sprintf(str, ": %d", anim->selectframe);
	anim->statusbar_time->SetText(str);

}

void TWinStatus::DisplayStatusTemp(Motion *m)
{
	TClientDC dc(*this);
	dc.SelectObject(TPen(cTextBG));
	dc.SelectObject(TBrush(cTextBG));
	dc.SetBkColor(TColor(cTextBG));
	if (m == NULL) {
		dc.SelectStockObject(WHITE_PEN);
		dc.Rectangle(dc.GetClipBox());
	} else if (m == anim->camera) {
		DisplayStatusCamera(dc, TRUE, anim->camera);
	} else if (m == anim->camera->target) {
		DisplayStatusTarget(dc, TRUE, anim->camera);
	} else {
		DisplayStatusObject(dc, TRUE, m);
	}
}

int TWinStatus::UpdateStatus(void)
{
	StatusMode nstat;
	switch (anim->opstat) {
	case OpDefault:
		if (anim->select == NULL) {
			nstat = STAT_NONE;
			anim->button_ok->Show(SW_HIDE);
			if (anim->motion == NULL) {
				anim->statusbar->SetText("[]/[̒ǉ] ŕ̂ǉĂ");
			} else {
				anim->statusbar->SetText("ɕ̂ǉ邩Aԃ}[NNbNĕ̂IĂ");
			}
		} else {
			anim->button_ok->Show(SW_SHOW);
			if (anim->select == anim->camera) {
				nstat = STAT_CAMERA;
				if (anim->camera->motiondata == NULL) {
					anim->statusbar->SetText("ԃ}[N𓮂AJʒuA^[QbgʒuύXĂ");
				} else {
					anim->statusbar->SetText("ԃ}[N𓮂AJʒuAړύXĂ");
				}
			} else if (anim->select == anim->camera->target) {
				nstat = STAT_TARGET;
				anim->statusbar->SetText("ԃ}[N𓮂A^[QbgʒuAړύXĂ");
			} else {
				nstat = STAT_OBJ;
				if (anim->gridflag) {
					anim->statusbar->SetText(":ړ :] :g CTRL:Obh SHIFT:sړ SHIFT:g E:m");
				} else {
					anim->statusbar->SetText(":ړ :] :g CTRL:ObhL SHIFT:sړ SHIFT:g E:m");
				}
			}
		}
		break;
	case OpLight:
		anim->statusbar->SetText("}[N𓮂A̕ݒ肵Ă  ENbN:m");
		anim->button_ok->Show(SW_SHOW);
		nstat = STAT_LIGHT;
		break;
	case OpSelZoom:
		anim->statusbar->SetText("Y[ʒuNbNĂ");
		anim->button_ok->Show(SW_HIDE);
		nstat = STAT_SELZOOM;
		break;
	case OpPlay:
		anim->statusbar->SetText("Đ𒆎~Ƃ͍NbNĂ");
		anim->button_ok->Show(SW_HIDE);
		nstat = STAT_PLAY;
		break;
	}
	if (nstat != nowstatus) {
		nowstatus = nstat;
		DisplayStatus(TRUE);
		return TRUE;
	}
	return FALSE;
}


void TWinStatus::Paint (TDC& dc, BOOL erase, TRect& rect)
{
	TWindow::Paint(dc, erase, rect);

	// INSERT>> ǉ̃R[h͂

	Redraw();
}



void TWinStatus::SetupWindow ()
{
	TWindow::SetupWindow();

	// INSERT>> ǉ̃R[h͂
	TClientDC dc(*this);
	TEXTMETRIC metric;
	dc.GetTextMetrics(metric);
	textheight = metric.tmHeight;
	textwidth = metric.tmAveCharWidth;
}


void TWinStatus::EvLButtonDown (UINT modKeys, TPoint& point)
{
	TWindow::EvLButtonDown(modKeys, point);

	// INSERT>> ǉR[h͂

	if (anim->opstat == OpPlay) {
		anim->OpModeDefault();
	} else if (anim->select != NULL &&
		(anim->select->motiondata == NULL
	  || anim->select->beginframe == anim->selectframe
	  || anim->select->endframe   == anim->selectframe)) {
		TDDirectInput dialog(this, anim, 0);
		if (dialog.Execute() == IDOK) {
			if (anim->selectframe < anim->select->beginframe) {
				anim->SelectFrame(anim->select->beginframe);
			} else if (anim->selectframe > anim->select->endframe) {
				anim->SelectFrame(anim->select->endframe);
			}
			if (anim->select->motiondata != NULL) {
				int pos = 0;
				Motion *m = anim->select;
				if (m->beginframe != anim->selectframe) {
					pos = 1;
				}
				if (anim->select == anim->camera || anim->select == anim->camera->target) {
					m = anim->camera;
					Motion *t = anim->camera->target;
					m->motiondata->bezier->MovePoint(pos*3, m->position);
					t->motiondata->bezier->MovePoint(pos*3, t->position);
				} else {
					m->motiondata->bezier->MovePoint(pos*3, m->position);
					m->motiondata->scale[pos] = m->scale;
					if (m->rotation != m->motiondata->rotation[pos]) {
						m->SetRotation(m->rotation, pos);
					} else {
						m->GetPosition(anim->selectframe);
					}
				}
			}
			if (anim->select == anim->camera || anim->select == anim->camera->target) {
				anim->camera->GetPosition(anim->selectframe);
				anim->CalcPoints(anim->camera);
				anim->CalcViewAll();
			} else {
				anim->CalcPoints(anim->select);
			}
			anim->editflag++;
			anim->Redraw();
		}
	} else if (anim->select != NULL && anim->select != anim->camera) {
		TDRange dialog(GetApplication()->GetMainWindow(), anim, anim->select,
						"J̈ړxEo/ݒ肵܂");
		if (dialog.Execute() == IDOK) {
			if (anim->selectframe < anim->select->beginframe) {
				anim->SelectFrame(anim->select->beginframe);
			} else if (anim->selectframe > anim->select->endframe) {
				anim->SelectFrame(anim->select->endframe);
			}
			anim->editflag++;
			anim->select->GetPosition(anim->selectframe);
			anim->CalcPoints(anim->select);
			anim->Redraw();
		}
	}
}

